/* mete123.c                                                 */
/* interface program between forward and lotus123 (c)        */
/* Author : Werner Depoorter (11-11-1991)                    */
/* Versie 2.1						     */

#include "stdio.h"
#include "stdlib.h"
#include "process.h"
#include "conio.h"
#include "math.h"
#include "time.h"

extern int errno;

#define EDATESOORT    201  /*  DATE-soort klopt niet                */
#define ENOJD         202  /*  Geen jd beschikbaar                  */
#define ENOKD         203  /*  Geen kd beschikbaar                  */
#define ENOT          204  /*  Geen T beschikbaar                   */
#define EEXCEN        205  /*  Onmogelijke excentriciteit           */

#define DegToRad(x) x*M_PI/180
#define RadToDeg(x) x*180/M_PI

typedef struct {
        int    soort;
            /* 1=JD 2=KD 4=T anders som van beschikbare */
        double    jd;
        double    t;
        int    jaar;
        int    maand;
        int    dag;
        int    uur;
        int    min;
        double    sec;
 }    DATE;


double dist;
double azibegin;
double power;
int elements;
char tracking;
double antazi, antelev;
double latd, latm, lats;
double longd, longm, longs;
int begday, begmonth, begyear, beghour;
int endday, endmonth, endyear, endhour;
double rvalue;
double radalfa, raddelta;
double delalfa, deldelta;
double heigth;

char line[80];
char path[40];
char zwerm[5];
char naam[10];
char remark[160];
DATE begin,einde,huidige;
int beginuur,einduur;
char file[15];
FILE *temp,*inp,*outp;
int vdag,vmaand,vjaar,vhour;
int ndag,nmaand,njaar,nhour;
double vobs,nobs;
int first;
clock_t time1,time2;
double elapsed;

void    calc_jd_kd(a)
DATE *a;
{    long Z,alfa,A,B,C,D,E;
    double F;
    if(a->soort&1)
    {    F=a->jd-floor(a->jd)+0.5;
        Z=(long)(a->jd);
        if ( F >= 1 ) { F--; Z++; };
        if ( Z >= 2299161 )
            { alfa=(long)((Z-1867216.25)/36524.25);
              A=Z+1+alfa-(long)(alfa/4);
             }
            else
            { A=Z;
             };
        B=A+1524;
        C=(long)((B-122.1)/365.25);
        D=(long)(365.25*C);
        E=(long)((B-D)/30.6001);
        a->dag=(int)(B-D-(long)(30.6001*E));
        a->maand=(int)((E<=13)?(E-1):(E-13));
        a->jaar=(int)((a->maand<=2)?(C-4715):(C-4716));
        F*=24;
        a->uur=(int)F;
        F=60*(F-floor(F));
        a->min=(int)F;
        a->sec=60*(F-floor(F));
        a->soort|=2;
     }
    else
    {    fprintf(stderr," Geen JD in calc_jd_kd\n");
        errno=ENOJD;
     };
 }; /* calc_jd_kd */

void    calc_kd_jd(a)
DATE *a;
{    int m,y,A,B;
    if(a->soort&2)
    {    if (a->maand>2)
        {    y=a->jaar;
            m=a->maand;
         }
        else
        {    y=a->jaar-1;
            m=a->maand+12;
         };
        if((a->jaar+a->maand/100.0+a->dag/10000.0) >= 1582.1015)
        {    A=(int)(y/100);
            B=2-A+(int)(A/4);
         }
        else
        {    B=0;
         };
        a->jd=(double)((long)(365.25*y)+(long)(30.6001*(m+1)));
        a->jd+=a->dag+((double)a->uur/24.0)+((double)a->min/1440)+(a->sec/86400);
        a->jd+=1720994.5+B;
        a->soort|=1;
     }
    else
    {    fprintf(stderr," Geen KD in calc_kd_jd\n");
        errno=ENOKD;
     };
 }; /* calc_kd_jd */


main()
{
   int i;

   clrscr();

   /* input data */

   printf("\n\n\n\tForward for Lotus 1-2-3\n");
   printf("\t***********************\n");
   printf("\t\t\t\tWritten by Werner Depoorter\n\n");
   printf("\tDistance between transmitter and receiver (km) ");
   scanf("%lf",&dist);
   printf("\tAzimuth transmitter ");
   scanf("%lf",&azibegin);
   printf("\tPower transmitter (kW) ");
   scanf("%lf",&power);
   printf("\tNumber of elements of Yagi ");
   scanf("%d",&elements);
   printf("\tAntenna : azim,elev (gr) ");
   scanf("%lf,%lf",&antazi,&antelev);
   printf("\tObserving place: Latitude  N : deg,m,s ");
   scanf("%lf,%lf,%lf",&latd,&latm,&lats);
   printf("\t                 Longitude E : deg,m,s ");
   scanf("%lf,%lf,%lf",&longd,&longm,&longs);
   printf("\tStart: day,month,year,hour ");
   scanf("%d,%d,%d,%d",&begday,&begmonth,&begyear,&beghour);
   printf("\tEnd  : day,month,year,hour ");
   scanf("%d,%d,%d,%d",&endday,&endmonth,&endyear,&endhour);
   printf("\tr value of stream ");
   scanf("%lf",&rvalue);
   printf("\tRadiant alfa(gr),delta(gr) (startday)  ");
   scanf("%lf,%lf",&radalfa,&raddelta);
   printf("\tRadiant drift (dAlfa(gr), dDelta (gr)) ");
   scanf("%lf,%lf",&delalfa,&deldelta);
   heigth=100;
   printf("\tZwermnaam (max 3 letters) ");
   scanf("%s",zwerm);
   printf("\tFilenaam (max 5 letters) ");
   scanf("%s",naam);
   printf("\tRemarks ");
   scanf("%s",remark);

   /*  Compute Observability function using Forward4
       and put data in 1 file                          */

   begin.soort=2;
   begin.jaar=begyear;
   begin.maand=begmonth;
   begin.dag=begday;
   begin.uur=0;
   begin.min=0;
   begin.sec=0.0L;
   calc_kd_jd(&begin);
   einde.soort=2;
   einde.jaar=endyear;
   einde.maand=endmonth;
   einde.dag=endday;
   einde.uur=0;
   einde.min=0;
   einde.sec=0.0L;
   calc_kd_jd(&einde);
   strcpy(path, "forward4.exe");
   clrscr();
   printf("\n\n\n");
   sprintf(file,"%3s%5s.for",zwerm,naam);
   for(i=0;i<8;i++) if (file[i]==' ') file[i]='_';
   if((outp=fopen(file,"w"))==NULL)
   { fprintf(stderr,"Can't open file %s for output\n",file);
     exit(4);
    };

   for(huidige.jd=begin.jd;huidige.jd<=einde.jd;huidige.jd++)
   { huidige.soort=1;
     calc_jd_kd(&huidige);
     if(huidige.jd==begin.jd) { beginuur=beghour; }
             else { beginuur=0; };
     if(huidige.jd==einde.jd) { einduur=endhour; }
             else { einduur=23; };
     printf("\tforward4 : %2d/%2d/%2d   %2d -> %2d ",huidige.dag,huidige.maand,huidige.jaar,beginuur,einduur);
     sprintf(file,"%4d%2d%2d.%3s",huidige.jaar,huidige.maand,huidige.dag,zwerm);
     for(i=0;i<8;i++) if (file[i]==' ') file[i]='0';
     for(i=9;i<12;i++) if (file[i]==' ') file[i]='_';
     if((temp=fopen("temp.tmp","w"))==NULL)
     { fprintf(stderr,"Can't open file temp.tmp for output\n");
       exit(2);
      };
     fprintf(temp,"%s\nnoremark\n",file);
     fprintf(temp,"%10.0lf\n",dist);
     fprintf(temp,"%6.2lf 1 1\n",azibegin);
     fprintf(temp,"%6.2lf\n",power);
     fprintf(temp,"%d\n",elements);
     if(tracking)
     { fprintf(temp,"y\n"); }
     else
     { fprintf(temp,"n\n%6.2lf %6.2lf\n",antazi,antelev); };
     fprintf(temp,"%6.2lf %6.2lf %6.2lf\n",latd,latm,lats);
     fprintf(temp,"%6.2lf %6.2lf %6.2lf\n",longd,longm,longs);
     fprintf(temp,"%d %d %d\n",huidige.dag,huidige.maand,huidige.jaar);
     fprintf(temp,"%d %d\n",beginuur,einduur);
     fprintf(temp,"%6.2lf\n",rvalue);
     fprintf(temp,"%6.2lf %6.2lf\n",radalfa,raddelta);
     radalfa+=delalfa;
     raddelta+=deldelta;
     fprintf(temp,"%8.2lf\n",heigth);
     fclose(temp);
     time1=clock();
     if(spawnl(P_WAIT, path, NULL)!=0)
     {  printf(" HELP !!!  "); }
     else
     {  printf(" OK !      "); };
     time2=clock();
     elapsed=((double)(time2-time1))/(double)CLK_TCK;
     printf("%7.2lfsec\n",elapsed);
     if((inp=fopen(file,"r"))==NULL)
     { fprintf(stderr,"Can't open file %s for input\n",file);
       exit(3);
      };
     if(huidige.jd==begin.jd)
     { while((line[0]=getc(inp))!=EOF)
       { putc(line[0],outp);
        };
      } else
     { for(i=0;i<66;i++)
       { fscanf(inp,"%s\n",line);
        };
       if((line[0]!='O')||(line[1]!='b')||(line[2]!='s'))
       { fprintf(stderr,"Error reading file %s\n",file);
         exit(5);
        };
       for(i=0;i<2;i++)
       { getc(inp);
        };
       while((line[0]=getc(inp))!=EOF)
       { putc(line[0],outp);
        };
      };
     fclose(inp);
    };
  fclose(outp);

  /* Convert file to ASCII for 123 */

  sprintf(file,"%3s%5s.123",zwerm,naam);
  for(i=0;i<8;i++) if (file[i]==' ') file[i]='_';
  if((outp=fopen(file,"w"))==NULL)
  { fprintf(stderr,"Can't open file %s for output\n",file);
    exit(6);
   };
  sprintf(file,"%3s%5s.for",zwerm,naam);
  for(i=0;i<8;i++) if (file[i]==' ') file[i]='_';
  if((inp=fopen(file,"r"))==NULL)
  { fprintf(stderr,"Can't open file %s for input\n",file);
    exit(4);
   };
  for(i=0;i<66;i++)
  { fscanf(inp,"%s\n",line);
   };
  if((line[0]!='O')||(line[1]!='b')||(line[2]!='s'))
  { fprintf(stderr,"Error reading file %s\n",file);
    exit(5);
   };
  for(i=0;i<2;i++)
  { getc(inp);
   };
  first=1;
  while((i=getc(inp))!=EOF)
  { ungetc(i,inp);
    fscanf(inp,"%s\n",line);
    ndag=atoi(line);
    fscanf(inp,"%s\n",line);
    switch(line[0])
    { case 'J': switch(line[1])
                { case 'a': nmaand=1;
                            break;
                  case 'u': switch(line[2])
                            { case 'n': nmaand=6;
                                        break;
                              case 'l': nmaand=7;
                                        break;
                             };
                            break;
                 };
                break;
      case 'F': nmaand=2;
                break;
      case 'M': switch(line[2])
                { case 'r': nmaand=3;
                            break;
                  case 'y': nmaand=5;
                            break;
                 };
                break;
      case 'A': switch(line[1])
                { case 'p': nmaand=4;
                            break;
                  case 'u': nmaand=8;
                            break;
                 };
                break;
      case 'S': nmaand=9;
                break;
      case 'O': nmaand=10;
                break;
      case 'N': nmaand=11;
                break;
      case 'D': nmaand=12;
                break;
      default : nmaand=0;
                break;
     };
    fscanf(inp,"%s\n",line);
    njaar=atoi(line);
    fscanf(inp,"%s\n",line);
    nhour=atoi(line);
    for(i=0;i<5;i++)
    { fscanf(inp,"%s\n",line);
     };
    fscanf(inp,"%s",line);
    nobs=atof(line);
    if((!first)&&(nmaand!=0))
    { fprintf(outp,"%2d\t%2d\t%4d\t%2d.00\t%2d.30\t%8.1lf\n",vdag,vmaand,vjaar,vhour,vhour,(3.0*vobs+1.0*nobs)/4.0);
      fprintf(outp,"%2d\t%2d\t%4d\t%2d.30\t%2d.00\t%8.1lf\n",vdag,vmaand,vjaar,vhour,(vhour!=23)?vhour+1:0,(1.0*vobs+3.0*nobs)/4.0);
     };
    vdag=ndag;
    vmaand=nmaand;
    vjaar=njaar;
    vhour=nhour;
    vobs=nobs;
    first=0;
   };
  fclose(inp);
  fclose(outp);

  return(0);
 };
